;(C)2004 AMX Mod X Development Team
; Licensed under the GNU General Public License
; Originally written by -=HaXoMaTiC=-
!define PRODUCT_NAME "AMX Mod X Installer"
!define PRODUCT_VERSION "1.8.2"
!define PRODUCT_PUBLISHER "AMX Mod X Dev Team"
!define PRODUCT_WEB_SITE "http://www.amxmodx.org/"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\Installer.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"
!define PRODUCT_STARTMENU_REGVAL "NSIS:StartMenuDir"

!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "installer\amxmodx.ico"
!define MUI_UNICON "installer\amxmodx.ico"

; Welcome page
!insertmacro MUI_PAGE_WELCOME
; License page
!define MUI_LICENSEPAGE_RADIOBUTTONS
!insertmacro MUI_PAGE_LICENSE "installer\gpl.txt"
; Directory page
!insertmacro MUI_PAGE_DIRECTORY
; Start menu page
var ICONS_GROUP
!define MUI_STARTMENUPAGE_NODISABLE
!define MUI_STARTMENUPAGE_DEFAULTFOLDER "AMX Mod X"
!define MUI_STARTMENUPAGE_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "${PRODUCT_STARTMENU_REGVAL}"
!insertmacro MUI_PAGE_STARTMENU Application $ICONS_GROUP
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_FINISHPAGE_RUN "$INSTDIR\Installer.exe"
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"

; Reserve files
!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "amxmodx-installer-${PRODUCT_VERSION}.exe"
InstallDir "$PROGRAMFILES\AMX Mod X"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show

Section "MainSection" SEC01
  SetOutPath "$INSTDIR"
  CreateDirectory "$INSTDIR\temp"
  SetOverwrite try
  File "installer\Installer.exe"
  SetOutPath "$INSTDIR\amxxstudio"
  File "installer\files\amxxstudio\AMXX_Studio.exe"
  File "installer\files\amxxstudio\SciLexer.dll"
  SetOutPath "$INSTDIR\amxxstudio\config"
  File "installer\files\amxxstudio\config\ACList.cfg"
  File "installer\files\amxxstudio\config\C++.csl"
  File "installer\files\amxxstudio\config\Cache.cfg"
  File "installer\files\amxxstudio\config\Editor.sci"
  File "installer\files\amxxstudio\config\Notes.dat"
  File "installer\files\amxxstudio\config\Other.csl"
  File "installer\files\amxxstudio\config\Pawn.csl"
  File "installer\files\amxxstudio\config\Plugins.cfg"
  File "installer\files\amxxstudio\config\Settings.ini"
  SetOutPath "$INSTDIR\amxxstudio\plugins"
  File "installer\files\amxxstudio\plugins\Functions and Events.htm"
  File "installer\files\amxxstudio\plugins\Hello World - CPP.dll"
  File "installer\files\amxxstudio\plugins\Hello World - Delphi.dll"
  SetOutPath "$INSTDIR\amxxstudio\plugins\Functions and Events-Files"
  File "installer\files\amxxstudio\plugins\Functions and Events-files\filelist.xml"
  File "installer\files\amxxstudio\plugins\Functions and Events-files\sheet001.htm"
  File "installer\files\amxxstudio\plugins\Functions and Events-files\sheet002.htm"
  File "installer\files\amxxstudio\plugins\Functions and Events-files\stylesheet.css"
  File "installer\files\amxxstudio\plugins\Functions and Events-files\tabstrip.htm"
  SetOutPath "$INSTDIR\amxxstudio\plugins\Hello_World CPP"
  File "installer\files\amxxstudio\plugins\Hello_World CPP\Hello_World.dsp"
  File "installer\files\amxxstudio\plugins\Hello_World CPP\Hello_World.dsw"
  File "installer\files\amxxstudio\plugins\Hello_World CPP\Hello_World.ncb"
  File "installer\files\amxxstudio\plugins\Hello_World CPP\Hello_World.opt"
  File "installer\files\amxxstudio\plugins\Hello_World CPP\Hello_World.plg"
  File "installer\files\amxxstudio\plugins\Hello_World CPP\Hello_World.sln"
  File "installer\files\amxxstudio\plugins\Hello_World CPP\Hello_World.suo"
  File "installer\files\amxxstudio\plugins\Hello_World CPP\Hello_World.vcproj"
  File "installer\files\amxxstudio\plugins\Hello_World CPP\sample.cpp"
  File "installer\files\amxxstudio\plugins\Hello_World CPP\sample.h"
  File "installer\files\amxxstudio\plugins\Hello_World CPP\studio_api.h"
  SetOutPath "$INSTDIR\amxxstudio\plugins\Hello_World Delphi"
  File "installer\files\amxxstudio\plugins\Hello_World Delphi\HelloWorld.cfg"
  File "installer\files\amxxstudio\plugins\Hello_World Delphi\HelloWorld.dof"
  File "installer\files\amxxstudio\plugins\Hello_World Delphi\HelloWorld.dpr"
  File "installer\files\amxxstudio\plugins\Hello_World Delphi\HelloWorld.res"
  File "installer\files\amxxstudio\plugins\Hello_World Delphi\studioapi.pas"
  SetOutPath "$INSTDIR\files\base\configs"
  File "installer\files\base\addons\amxmodx\configs\amxx.cfg"
  File "installer\files\base\addons\amxmodx\configs\clcmds.ini"
  File "installer\files\base\addons\amxmodx\configs\cmds.ini"
  File "installer\files\base\addons\amxmodx\configs\configs.ini"
  File "installer\files\base\addons\amxmodx\configs\core.ini"
  File "installer\files\base\addons\amxmodx\configs\custommenuitems.cfg"
  File "installer\files\base\addons\amxmodx\configs\cvars.ini"
  File "installer\files\base\addons\amxmodx\configs\hamdata.ini"
  File "installer\files\base\addons\amxmodx\configs\maps.ini"
  File "installer\files\base\addons\amxmodx\configs\modules.ini"
  File "installer\files\base\addons\amxmodx\configs\plugins.ini"
  File "installer\files\base\addons\amxmodx\configs\speech.ini"
  File "installer\files\base\addons\amxmodx\configs\sql.cfg"
  File "installer\files\base\addons\amxmodx\configs\users.ini"
  SetOutPath "$INSTDIR\files\base\data"
  File "installer\files\base\addons\amxmodx\data\GeoIP.dat"
  SetOutPath "$INSTDIR\files\base\data\lang"
  File "installer\files\base\addons\amxmodx\data\lang\admin.txt"
  File "installer\files\base\addons\amxmodx\data\lang\adminchat.txt"
  File "installer\files\base\addons\amxmodx\data\lang\admincmd.txt"
  File "installer\files\base\addons\amxmodx\data\lang\adminhelp.txt"
  File "installer\files\base\addons\amxmodx\data\lang\adminslots.txt"
  File "installer\files\base\addons\amxmodx\data\lang\adminvote.txt"
  File "installer\files\base\addons\amxmodx\data\lang\antiflood.txt"
  File "installer\files\base\addons\amxmodx\data\lang\cmdmenu.txt"
  File "installer\files\base\addons\amxmodx\data\lang\common.txt"
  File "installer\files\base\addons\amxmodx\data\lang\imessage.txt"
  File "installer\files\base\addons\amxmodx\data\lang\languages.txt"
  File "installer\files\base\addons\amxmodx\data\lang\mapchooser.txt"
  File "installer\files\base\addons\amxmodx\data\lang\mapsmenu.txt"
  File "installer\files\base\addons\amxmodx\data\lang\menufront.txt"
  File "installer\files\base\addons\amxmodx\data\lang\miscstats.txt"
  File "installer\files\base\addons\amxmodx\data\lang\multilingual.txt"
  File "installer\files\base\addons\amxmodx\data\lang\nextmap.txt"
  File "installer\files\base\addons\amxmodx\data\lang\pausecfg.txt"
  File "installer\files\base\addons\amxmodx\data\lang\plmenu.txt"
  File "installer\files\base\addons\amxmodx\data\lang\restmenu.txt"
  File "installer\files\base\addons\amxmodx\data\lang\scrollmsg.txt"
  File "installer\files\base\addons\amxmodx\data\lang\statscfg.txt"
  File "installer\files\base\addons\amxmodx\data\lang\statsx.txt"
  File "installer\files\base\addons\amxmodx\data\lang\stats_dod.txt"
  File "installer\files\base\addons\amxmodx\data\lang\telemenu.txt"
  File "installer\files\base\addons\amxmodx\data\lang\time.txt"
  File "installer\files\base\addons\amxmodx\data\lang\timeleft.txt"
  SetOutPath "$INSTDIR\files\base\dlls"
  File "installer\files\base\addons\amxmodx\dlls\amxmodx_mm.dll"
  File "installer\files\base\addons\amxmodx\dlls\amxmodx_mm.dylib"
  File "installer\files\base\addons\amxmodx\dlls\amxmodx_mm_i386.so"
  File "installer\files\base\addons\amxmodx\dlls\metamod.dll"
  File "installer\files\base\addons\amxmodx\dlls\metamod.dylib"
  File "installer\files\base\addons\amxmodx\dlls\metamod.so"
  SetOutPath "$INSTDIR\files\base\modules"
  File "installer\files\base\addons\amxmodx\modules\nvault_amxx.dll"
  File "installer\files\base\addons\amxmodx\modules\nvault_amxx.dylib"
  File "installer\files\base\addons\amxmodx\modules\nvault_amxx_i386.so"
  File "installer\files\base\addons\amxmodx\modules\engine_amxx.dll"
  File "installer\files\base\addons\amxmodx\modules\engine_amxx.dylib"
  File "installer\files\base\addons\amxmodx\modules\engine_amxx_i386.so"
  File "installer\files\base\addons\amxmodx\modules\fakemeta_amxx.dll"
  File "installer\files\base\addons\amxmodx\modules\fakemeta_amxx.dylib"
  File "installer\files\base\addons\amxmodx\modules\fakemeta_amxx_i386.so"
  File "installer\files\base\addons\amxmodx\modules\fun_amxx.dll"
  File "installer\files\base\addons\amxmodx\modules\fun_amxx.dylib"
  File "installer\files\base\addons\amxmodx\modules\fun_amxx_i386.so"
  File "installer\files\base\addons\amxmodx\modules\geoip_amxx.dll"
  File "installer\files\base\addons\amxmodx\modules\geoip_amxx.dylib"
  File "installer\files\base\addons\amxmodx\modules\geoip_amxx_i386.so"
  File "installer\files\base\addons\amxmodx\modules\sqlite_amxx.dll"
  File "installer\files\base\addons\amxmodx\modules\sqlite_amxx.dylib"
  File "installer\files\base\addons\amxmodx\modules\sqlite_amxx_i386.so"
  File "installer\files\base\addons\amxmodx\modules\mysql_amxx.dll"
  File "installer\files\base\addons\amxmodx\modules\mysql_amxx.dylib"
  File "installer\files\base\addons\amxmodx\modules\mysql_amxx_i386.so"
  File "installer\files\base\addons\amxmodx\modules\regex_amxx.dll"
  File "installer\files\base\addons\amxmodx\modules\regex_amxx.dylib"
  File "installer\files\base\addons\amxmodx\modules\regex_amxx_i386.so"
  File "installer\files\base\addons\amxmodx\modules\sockets_amxx.dll"
  File "installer\files\base\addons\amxmodx\modules\sockets_amxx.dylib"
  File "installer\files\base\addons\amxmodx\modules\sockets_amxx_i386.so"
  File "installer\files\base\addons\amxmodx\modules\hamsandwich_amxx.dll"
  File "installer\files\base\addons\amxmodx\modules\hamsandwich_amxx.dylib"
  File "installer\files\base\addons\amxmodx\modules\hamsandwich_amxx_i386.so"
  SetOutPath "$INSTDIR\files\base\plugins"
  File "installer\files\base\addons\amxmodx\plugins\admin.amxx"
  File "installer\files\base\addons\amxmodx\plugins\adminchat.amxx"
  File "installer\files\base\addons\amxmodx\plugins\admincmd.amxx"
  File "installer\files\base\addons\amxmodx\plugins\adminhelp.amxx"
  File "installer\files\base\addons\amxmodx\plugins\adminslots.amxx"
  File "installer\files\base\addons\amxmodx\plugins\adminvote.amxx"
  File "installer\files\base\addons\amxmodx\plugins\admin_sql.amxx"
  File "installer\files\base\addons\amxmodx\plugins\amxmod_compat.amxx"
  File "installer\files\base\addons\amxmodx\plugins\antiflood.amxx"
  File "installer\files\base\addons\amxmodx\plugins\cmdmenu.amxx"
  File "installer\files\base\addons\amxmodx\plugins\imessage.amxx"
  File "installer\files\base\addons\amxmodx\plugins\mapchooser.amxx"
  File "installer\files\base\addons\amxmodx\plugins\mapsmenu.amxx"
  File "installer\files\base\addons\amxmodx\plugins\menufront.amxx"
  File "installer\files\base\addons\amxmodx\plugins\multilingual.amxx"
  File "installer\files\base\addons\amxmodx\plugins\nextmap.amxx"
  File "installer\files\base\addons\amxmodx\plugins\pausecfg.amxx"
  File "installer\files\base\addons\amxmodx\plugins\plmenu.amxx"
  File "installer\files\base\addons\amxmodx\plugins\pluginmenu.amxx"
  File "installer\files\base\addons\amxmodx\plugins\scrollmsg.amxx"
  File "installer\files\base\addons\amxmodx\plugins\statscfg.amxx"
  File "installer\files\base\addons\amxmodx\plugins\telemenu.amxx"
  File "installer\files\base\addons\amxmodx\plugins\timeleft.amxx"
  SetOutPath "$INSTDIR\files\base\scripting"
  File "installer\files\base\addons\amxmodx\scripting\admin.sma"
  File "installer\files\base\addons\amxmodx\scripting\adminchat.sma"
  File "installer\files\base\addons\amxmodx\scripting\admincmd.sma"
  File "installer\files\base\addons\amxmodx\scripting\adminhelp.sma"
  File "installer\files\base\addons\amxmodx\scripting\adminslots.sma"
  File "installer\files\base\addons\amxmodx\scripting\adminvote.sma"
  File "installer\files\base\addons\amxmodx\scripting\amxxpc"
  File "installer\files\base\addons\amxmodx\scripting\amxxpc.exe"
  File "installer\files\base\addons\amxmodx\scripting\amxxpc32.dll"
  File "installer\files\base\addons\amxmodx\scripting\amxxpc32.dylib"
  File "installer\files\base\addons\amxmodx\scripting\amxxpc32.so"
  File "installer\files\base\addons\amxmodx\scripting\amxxpc_osx"
  File "installer\files\base\addons\amxmodx\scripting\antiflood.sma"
  File "installer\files\base\addons\amxmodx\scripting\cmdmenu.sma"
  File "installer\files\base\addons\amxmodx\scripting\compile.exe"
  File "installer\files\base\addons\amxmodx\scripting\compile.sh"
  File "installer\files\base\addons\amxmodx\scripting\imessage.sma"
  SetOutPath "$INSTDIR\files\base\scripting\include"
  File "installer\files\base\addons\amxmodx\scripting\include\amxconst.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\amxmisc.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\amxmodx.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\cellarray.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\celltrie.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\core.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\csstats.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\cstrike.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\csx.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\dbi.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\dodconst.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\dodfun.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\dodstats.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\dodx.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\engine.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\engine_const.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\engine_stocks.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\esf.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\esf_const.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\fakemeta.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\fakemeta_const.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\fakemeta_stocks.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\fakemeta_util.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\file.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\float.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\fun.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\geoip.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\ham_const.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\hamsandwich.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\hlsdk_const.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\hlsdk_const.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\lang.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\messages.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\message_const.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\message_stocks.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\ns.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\ns2amx.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\ns_const.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\regex.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\newmenus.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\nvault.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\sockets.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\sorting.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\sqlx.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\string.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\svn_version.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\tfcconst.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\tfcstats.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\tfcx.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\time.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\tsconst.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\tsfun.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\tsstats.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\tsx.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\vault.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\vector.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\xs.inc"
  SetOutPath "$INSTDIR\files\base\scripting\include\amxmod_compat"
  File "installer\files\base\addons\amxmodx\scripting\include\amxmod_compat\amxmod.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\amxmod_compat\maths.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\amxmod_compat\mysql.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\amxmod_compat\translator.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\amxmod_compat\Vexd_Utilities.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\amxmod_compat\VexdUM.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\amxmod_compat\VexdUM_const.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\amxmod_compat\VexdUM_stock.inc"
  File "installer\files\base\addons\amxmodx\scripting\include\amxmod_compat\xtrafun.inc"
  SetOutPath "$INSTDIR\files\base\scripting"
  File "installer\files\base\addons\amxmodx\scripting\mapchooser.sma"
  File "installer\files\base\addons\amxmodx\scripting\mapsmenu.sma"
  File "installer\files\base\addons\amxmodx\scripting\menufront.sma"
  File "installer\files\base\addons\amxmodx\scripting\multilingual.sma"
  File "installer\files\base\addons\amxmodx\scripting\nextmap.sma"
  File "installer\files\base\addons\amxmodx\scripting\pausecfg.sma"
  File "installer\files\base\addons\amxmodx\scripting\plmenu.sma"
  File "installer\files\base\addons\amxmodx\scripting\pluginmenu.sma"
  File "installer\files\base\addons\amxmodx\scripting\scrollmsg.sma"
  File "installer\files\base\addons\amxmodx\scripting\statscfg.sma"
  File "installer\files\base\addons\amxmodx\scripting\telemenu.sma"
  File "installer\files\base\addons\amxmodx\scripting\timeleft.sma"
  SetOutPath "$INSTDIR\files\base\scripting\amxmod_compat"
  File "installer\files\base\addons\amxmodx\scripting\amxmod_compat\amxmod_compat.sma"
  File "installer\files\base\addons\amxmodx\scripting\amxmod_compat\core.sma"
  File "installer\files\base\addons\amxmodx\scripting\amxmod_compat\mysql.sma"
  File "installer\files\base\addons\amxmodx\scripting\amxmod_compat\vexdum.sma"
  SetOutPath "$INSTDIR\files\base\scripting\testsuite"
  File "installer\files\base\addons\amxmodx\scripting\testsuite\admins_test.sma"
  File "installer\files\base\addons\amxmodx\scripting\testsuite\arraytest.sma"
  File "installer\files\base\addons\amxmodx\scripting\testsuite\callfunc_test.sma"
  File "installer\files\base\addons\amxmodx\scripting\testsuite\fakemeta_tests.sma"
  File "installer\files\base\addons\amxmodx\scripting\testsuite\fmttest.sma"
  File "installer\files\base\addons\amxmodx\scripting\testsuite\fwdtest1.sma"
  File "installer\files\base\addons\amxmodx\scripting\testsuite\fwdtest2.sma"
  File "installer\files\base\addons\amxmodx\scripting\testsuite\logtest.sma"
  File "installer\files\base\addons\amxmodx\scripting\testsuite\menutest.sma"
  File "installer\files\base\addons\amxmodx\scripting\testsuite\native_test.sma"
  File "installer\files\base\addons\amxmodx\scripting\testsuite\nvault_test.sma"
  File "installer\files\base\addons\amxmodx\scripting\testsuite\sorttest.sma"
  File "installer\files\base\addons\amxmodx\scripting\testsuite\sqlxtest.sma"
  File "installer\files\base\addons\amxmodx\scripting\testsuite\sqlxtest.sq3"
  File "installer\files\base\addons\amxmodx\scripting\testsuite\sqlxtest.sql"
  File "installer\files\base\addons\amxmodx\scripting\testsuite\trietest.sma"
  SetOutPath "$INSTDIR\files\cstrike\configs"
  File "installer\files\cstrike\addons\amxmodx\configs\amxx.cfg"
  File "installer\files\cstrike\addons\amxmodx\configs\cmds.ini"
  File "installer\files\cstrike\addons\amxmodx\configs\core.ini"
  File "installer\files\cstrike\addons\amxmodx\configs\cvars.ini"
  File "installer\files\cstrike\addons\amxmodx\configs\maps.ini"
  File "installer\files\cstrike\addons\amxmodx\configs\modules.ini"
  File "installer\files\cstrike\addons\amxmodx\configs\plugins.ini"
  File "installer\files\cstrike\addons\amxmodx\configs\stats.ini"
  SetOutPath "$INSTDIR\files\cstrike\data"
  File "installer\files\cstrike\addons\amxmodx\data\csstats.amxx"
  File "installer\files\cstrike\addons\amxmodx\data\WinCSX.exe"
  SetOutPath "$INSTDIR\files\cstrike\modules"
  File "installer\files\cstrike\addons\amxmodx\modules\cstrike_amxx.dll"
  File "installer\files\cstrike\addons\amxmodx\modules\cstrike_amxx.dylib"
  File "installer\files\cstrike\addons\amxmodx\modules\cstrike_amxx_i386.so"
  File "installer\files\cstrike\addons\amxmodx\modules\csx_amxx.dll"
  File "installer\files\cstrike\addons\amxmodx\modules\csx_amxx.dylib"
  File "installer\files\cstrike\addons\amxmodx\modules\csx_amxx_i386.so"
  SetOutPath "$INSTDIR\files\cstrike\plugins"
  File "installer\files\cstrike\addons\amxmodx\plugins\miscstats.amxx"
  File "installer\files\cstrike\addons\amxmodx\plugins\restmenu.amxx"
  File "installer\files\cstrike\addons\amxmodx\plugins\statsx.amxx"
  File "installer\files\cstrike\addons\amxmodx\plugins\stats_logging.amxx"
  SetOutPath "$INSTDIR\files\cstrike\scripting"
  File "installer\files\cstrike\addons\amxmodx\scripting\csstats.sma"
  File "installer\files\cstrike\addons\amxmodx\scripting\miscstats.sma"
  File "installer\files\cstrike\addons\amxmodx\scripting\restmenu.sma"
  File "installer\files\cstrike\addons\amxmodx\scripting\statsx.sma"
  File "installer\files\cstrike\addons\amxmodx\scripting\stats_logging.sma"
  SetOutPath "$INSTDIR\files\dod\configs"
  File "installer\files\dod\addons\amxmodx\configs\core.ini"
  File "installer\files\dod\addons\amxmodx\configs\cvars.ini"
  File "installer\files\dod\addons\amxmodx\configs\maps.ini"
  File "installer\files\dod\addons\amxmodx\configs\modules.ini"
  File "installer\files\dod\addons\amxmodx\configs\plugins.ini"
  SetOutPath "$INSTDIR\files\dod\data"
  File "installer\files\dod\addons\amxmodx\data\dodstats.amxx"
  SetOutPath "$INSTDIR\files\dod\modules"
  File "installer\files\dod\addons\amxmodx\modules\dodfun_amxx.dll"
  File "installer\files\dod\addons\amxmodx\modules\dodfun_amxx.dylib"
  File "installer\files\dod\addons\amxmodx\modules\dodfun_amxx_i386.so"
  File "installer\files\dod\addons\amxmodx\modules\dodx_amxx.dll"
  File "installer\files\dod\addons\amxmodx\modules\dodx_amxx.dylib"
  File "installer\files\dod\addons\amxmodx\modules\dodx_amxx_i386.so"
  SetOutPath "$INSTDIR\files\dod\plugins"
  File "installer\files\dod\addons\amxmodx\plugins\plmenu.amxx"
  File "installer\files\dod\addons\amxmodx\plugins\stats.amxx"
  File "installer\files\dod\addons\amxmodx\plugins\statssounds.amxx"
  File "installer\files\dod\addons\amxmodx\plugins\stats_logging.amxx"
  SetOutPath "$INSTDIR\files\dod\scripting"
  File "installer\files\dod\addons\amxmodx\scripting\dodstats.sma"
  File "installer\files\dod\addons\amxmodx\scripting\plmenu.sma"
  File "installer\files\dod\addons\amxmodx\scripting\stats.sma"
  File "installer\files\dod\addons\amxmodx\scripting\statssounds.sma"
  File "installer\files\dod\addons\amxmodx\scripting\stats_logging.sma"
  SetOutPath "$INSTDIR\files\ns\configs"
  File "installer\files\ns\addons\amxmodx\configs\amxx.cfg"
  File "installer\files\ns\addons\amxmodx\configs\clcmds.ini"
  File "installer\files\ns\addons\amxmodx\configs\cmds.ini"
  File "installer\files\ns\addons\amxmodx\configs\cvars.ini"
  File "installer\files\ns\addons\amxmodx\configs\maps.ini"
  File "installer\files\ns\addons\amxmodx\configs\modules.ini"
  File "installer\files\ns\addons\amxmodx\configs\plugins.ini"
  File "installer\files\ns\addons\amxmodx\configs\speech.ini"
  File "installer\files\ns\addons\amxmodx\configs\users.ini"
  SetOutPath "$INSTDIR\files\ns\modules"
  File "installer\files\ns\addons\amxmodx\modules\ns_amxx.dll"
  File "installer\files\ns\addons\amxmodx\modules\ns_amxx_i386.so"
  SetOutPath "$INSTDIR\files\ns\plugins"
  File "installer\files\ns\addons\amxmodx\plugins\idlekicker.amxx"
  File "installer\files\ns\addons\amxmodx\plugins\mapchooser.amxx"
  File "installer\files\ns\addons\amxmodx\plugins\nextmap.amxx"
  File "installer\files\ns\addons\amxmodx\plugins\nscommands.amxx"
  File "installer\files\ns\addons\amxmodx\plugins\timeleft.amxx"
  File "installer\files\ns\addons\amxmodx\plugins\unstuck.amxx"
  SetOutPath "$INSTDIR\files\ns\scripting"
  File "installer\files\ns\addons\amxmodx\scripting\idlekicker.sma"
  File "installer\files\ns\addons\amxmodx\scripting\mapchooser.sma"
  File "installer\files\ns\addons\amxmodx\scripting\nextmap.sma"
  File "installer\files\ns\addons\amxmodx\scripting\nscommands.sma"
  File "installer\files\ns\addons\amxmodx\scripting\timeleft.sma"
  File "installer\files\ns\addons\amxmodx\scripting\unstuck.sma"
  SetOutPath "$INSTDIR\files\esf\configs"
  File "installer\files\esf\addons\amxmodx\configs\modules.ini"
  File "installer\files\esf\addons\amxmodx\configs\plugins.ini"
  SetOutPath "$INSTDIR\files\esf\scripting"
  File "installer\files\esf\addons\amxmodx\scripting\ESF_mod_tutorial.txt"
  File "installer\files\esf\addons\amxmodx\scripting\EvolutionX.Core.sma"
  SetOutPath "$INSTDIR\files\esf\plugins"
  File "installer\files\esf\addons\amxmodx\plugins\EvolutionX.Core.amxx"
  SetOutPath "$INSTDIR\files\tfc\configs"
  File "installer\files\tfc\addons\amxmodx\configs\core.ini"
  File "installer\files\tfc\addons\amxmodx\configs\cvars.ini"
  File "installer\files\tfc\addons\amxmodx\configs\maps.ini"
  File "installer\files\tfc\addons\amxmodx\configs\modules.ini"
  File "installer\files\tfc\addons\amxmodx\configs\plugins.ini"
  SetOutPath "$INSTDIR\files\tfc\data"
  File "installer\files\tfc\addons\amxmodx\data\tfcstats.amxx"
  SetOutPath "$INSTDIR\files\tfc\modules"
  File "installer\files\tfc\addons\amxmodx\modules\tfcx_amxx.dll"
  File "installer\files\tfc\addons\amxmodx\modules\tfcx_amxx.dylib"
  File "installer\files\tfc\addons\amxmodx\modules\tfcx_amxx_i386.so"
  SetOutPath "$INSTDIR\files\tfc\plugins"
  File "installer\files\tfc\addons\amxmodx\plugins\plmenu.amxx"
  File "installer\files\tfc\addons\amxmodx\plugins\stats.amxx"
  File "installer\files\tfc\addons\amxmodx\plugins\statssounds.amxx"
  File "installer\files\tfc\addons\amxmodx\plugins\stats_logging.amxx"
  SetOutPath "$INSTDIR\files\tfc\scripting"
  File "installer\files\tfc\addons\amxmodx\scripting\plmenu.sma"
  File "installer\files\tfc\addons\amxmodx\scripting\stats.sma"
  File "installer\files\tfc\addons\amxmodx\scripting\statssounds.sma"
  File "installer\files\tfc\addons\amxmodx\scripting\stats_logging.sma"
  File "installer\files\tfc\addons\amxmodx\scripting\tfcstats.sma"
  SetOutPath "$INSTDIR\files\ts\configs"
  File "installer\files\ts\addons\amxmodx\configs\core.ini"
  File "installer\files\ts\addons\amxmodx\configs\maps.ini"
  File "installer\files\ts\addons\amxmodx\configs\modules.ini"
  File "installer\files\ts\addons\amxmodx\configs\plugins.ini"
  SetOutPath "$INSTDIR\files\ts\data"
  File "installer\files\ts\addons\amxmodx\data\tsstats.amxx"
  SetOutPath "$INSTDIR\files\ts\modules"
  File "installer\files\ts\addons\amxmodx\modules\tsx_amxx.dll"
  File "installer\files\ts\addons\amxmodx\modules\tsx_amxx_i386.so"
  File "installer\files\ts\addons\amxmodx\modules\tsfun_amxx.dll"
  File "installer\files\ts\addons\amxmodx\modules\tsfun_amxx_i386.so"
  SetOutPath "$INSTDIR\files\ts\plugins"
  File "installer\files\ts\addons\amxmodx\plugins\stats.amxx"
  File "installer\files\ts\addons\amxmodx\plugins\statssounds.amxx"
  File "installer\files\ts\addons\amxmodx\plugins\stats_logging.amxx"
  SetOutPath "$INSTDIR\files\ts\scripting"
  File "installer\files\ts\addons\amxmodx\scripting\stats.sma"
  File "installer\files\ts\addons\amxmodx\scripting\statssounds.sma"
  File "installer\files\ts\addons\amxmodx\scripting\stats_logging.sma"
  File "installer\files\ts\addons\amxmodx\scripting\tsstats.sma"
  SetOutPath "$INSTDIR\"
  File "installer\gpl.txt"

; Shortcuts
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
  CreateDirectory "$SMPROGRAMS\$ICONS_GROUP"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\AMX Mod X.lnk" "$INSTDIR\Installer.exe"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\AMXx Studio.lnk" "$INSTDIR\amxxstudio\AMXX_Studio.exe"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Documentation.lnk" "http://wiki.tcwonline.org/index.php/Category:Documentation_%28AMX_Mod_X%29"
  CreateShortCut "$DESKTOP\AMX Mod X Studio.lnk" "$INSTDIR\amxxstudio\AMXX_Studio.exe"
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

Section -AdditionalIcons
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Website.lnk" "$INSTDIR\${PRODUCT_NAME}.url"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk" "$INSTDIR\uninst.exe"
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\Installer.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\Installer.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd


Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) was successfully removed from your computer."
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove $(^Name) and all of its components?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  !insertmacro MUI_STARTMENU_GETFOLDER "Application" $ICONS_GROUP
  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\gpl.txt"
  Delete "$INSTDIR\files\esf\configs\plugins.ini"
  Delete "$INSTDIR\files\esf\configs\modules.ini"
  Delete "$INSTDIR\files\esf\scripting\EvolutionX.Core.sma"
  Delete "$INSTDIR\files\esf\scripting\ESF_mod_tutorial.txt"
  Delete "$INSTDIR\files\esf\plugins\EvolutionX.Core.amxx"
  Delete "$INSTDIR\files\ts\scripting\tsstats.sma"
  Delete "$INSTDIR\files\ts\scripting\stats_logging.sma"
  Delete "$INSTDIR\files\ts\scripting\statssounds.sma"
  Delete "$INSTDIR\files\ts\scripting\stats.sma"
  Delete "$INSTDIR\files\ts\plugins\stats_logging.amxx"
  Delete "$INSTDIR\files\ts\plugins\statssounds.amxx"
  Delete "$INSTDIR\files\ts\plugins\stats.amxx"
  Delete "$INSTDIR\files\ts\modules\tsx_amxx_i386.so"
  Delete "$INSTDIR\files\ts\modules\tsx_amxx.dll"
  Delete "$INSTDIR\files\ts\modules\tsfun_amxx_i386.so"
  Delete "$INSTDIR\files\ts\modules\tsfun_amxx.dll"
  Delete "$INSTDIR\files\ts\data\tsstats.amxx"
  Delete "$INSTDIR\files\ts\configs\plugins.ini"
  Delete "$INSTDIR\files\ts\configs\modules.ini"
  Delete "$INSTDIR\files\ts\configs\maps.ini"
  Delete "$INSTDIR\files\ts\configs\core.ini"
  Delete "$INSTDIR\files\tfc\scripting\tfcstats.sma"
  Delete "$INSTDIR\files\tfc\scripting\stats_logging.sma"
  Delete "$INSTDIR\files\tfc\scripting\statssounds.sma"
  Delete "$INSTDIR\files\tfc\scripting\stats.sma"
  Delete "$INSTDIR\files\tfc\scripting\plmenu.sma"
  Delete "$INSTDIR\files\tfc\plugins\stats_logging.amxx"
  Delete "$INSTDIR\files\tfc\plugins\statssounds.amxx"
  Delete "$INSTDIR\files\tfc\plugins\stats.amxx"
  Delete "$INSTDIR\files\tfc\plugins\plmenu.amxx"
  Delete "$INSTDIR\files\tfc\modules\tfcx_amxx_i386.so"
  Delete "$INSTDIR\files\tfc\modules\tfcx_amxx.dylib"
  Delete "$INSTDIR\files\tfc\modules\tfcx_amxx.dll"
  Delete "$INSTDIR\files\tfc\data\tfcstats.amxx"
  Delete "$INSTDIR\files\tfc\configs\plugins.ini"
  Delete "$INSTDIR\files\tfc\configs\modules.ini"
  Delete "$INSTDIR\files\tfc\configs\maps.ini"
  Delete "$INSTDIR\files\tfc\configs\cvars.ini"
  Delete "$INSTDIR\files\tfc\configs\core.ini"
  Delete "$INSTDIR\files\ns\scripting\unstuck.sma"
  Delete "$INSTDIR\files\ns\scripting\timeleft.sma"
  Delete "$INSTDIR\files\ns\scripting\nscommands.sma"
  Delete "$INSTDIR\files\ns\scripting\nextmap.sma"
  Delete "$INSTDIR\files\ns\scripting\mapchooser.sma"
  Delete "$INSTDIR\files\ns\scripting\idlekicker.sma"
  Delete "$INSTDIR\files\ns\plugins\unstuck.amxx"
  Delete "$INSTDIR\files\ns\plugins\timeleft.amxx"
  Delete "$INSTDIR\files\ns\plugins\nscommands.amxx"
  Delete "$INSTDIR\files\ns\plugins\nextmap.amxx"
  Delete "$INSTDIR\files\ns\plugins\mapchooser.amxx"
  Delete "$INSTDIR\files\ns\plugins\idlekicker.amxx"
  Delete "$INSTDIR\files\ns\modules\ns_amxx_i386.so"
  Delete "$INSTDIR\files\ns\modules\ns_amxx.dll"
  Delete "$INSTDIR\files\ns\configs\users.ini"
  Delete "$INSTDIR\files\ns\configs\speech.ini"
  Delete "$INSTDIR\files\ns\configs\plugins.ini"
  Delete "$INSTDIR\files\ns\configs\modules.ini"
  Delete "$INSTDIR\files\ns\configs\maps.ini"
  Delete "$INSTDIR\files\ns\configs\cvars.ini"
  Delete "$INSTDIR\files\ns\configs\cmds.ini"
  Delete "$INSTDIR\files\ns\configs\clcmds.ini"
  Delete "$INSTDIR\files\ns\configs\amxx.cfg"
  Delete "$INSTDIR\files\dod\scripting\stats_logging.sma"
  Delete "$INSTDIR\files\dod\scripting\statssounds.sma"
  Delete "$INSTDIR\files\dod\scripting\stats.sma"
  Delete "$INSTDIR\files\dod\scripting\plmenu.sma"
  Delete "$INSTDIR\files\dod\scripting\dodstats.sma"
  Delete "$INSTDIR\files\dod\plugins\stats_logging.amxx"
  Delete "$INSTDIR\files\dod\plugins\statssounds.amxx"
  Delete "$INSTDIR\files\dod\plugins\stats.amxx"
  Delete "$INSTDIR\files\dod\plugins\plmenu.amxx"
  Delete "$INSTDIR\files\dod\modules\dodx_amxx_i386.so"
  Delete "$INSTDIR\files\dod\modules\dodx_amxx.dylib"
  Delete "$INSTDIR\files\dod\modules\dodx_amxx.dll"
  Delete "$INSTDIR\files\dod\modules\dodfun_amxx_i386.so"
  Delete "$INSTDIR\files\dod\modules\dodfun_amxx.dylib"
  Delete "$INSTDIR\files\dod\modules\dodfun_amxx.dll"
  Delete "$INSTDIR\files\dod\data\dodstats.amxx"
  Delete "$INSTDIR\files\dod\configs\plugins.ini"
  Delete "$INSTDIR\files\dod\configs\modules.ini"
  Delete "$INSTDIR\files\dod\configs\maps.ini"
  Delete "$INSTDIR\files\dod\configs\cvars.ini"
  Delete "$INSTDIR\files\dod\configs\core.ini"
  Delete "$INSTDIR\files\cstrike\scripting\stats_logging.sma"
  Delete "$INSTDIR\files\cstrike\scripting\statsx.sma"
  Delete "$INSTDIR\files\cstrike\scripting\restmenu.sma"
  Delete "$INSTDIR\files\cstrike\scripting\miscstats.sma"
  Delete "$INSTDIR\files\cstrike\scripting\csstats.sma"
  Delete "$INSTDIR\files\cstrike\plugins\stats_logging.amxx"
  Delete "$INSTDIR\files\cstrike\plugins\statsx.amxx"
  Delete "$INSTDIR\files\cstrike\plugins\restmenu.amxx"
  Delete "$INSTDIR\files\cstrike\plugins\miscstats.amxx"
  Delete "$INSTDIR\files\cstrike\modules\csx_amxx_i386.so"
  Delete "$INSTDIR\files\cstrike\modules\csx_amxx.dylib"
  Delete "$INSTDIR\files\cstrike\modules\csx_amxx.dll"
  Delete "$INSTDIR\files\cstrike\modules\cstrike_amxx_i386.so"
  Delete "$INSTDIR\files\cstrike\modules\cstrike_amxx.dylib"
  Delete "$INSTDIR\files\cstrike\modules\cstrike_amxx.dll"
  Delete "$INSTDIR\files\cstrike\data\csstats.amxx"
  Delete "$INSTDIR\files\cstrike\data\WinCSX.exe"
  Delete "$INSTDIR\files\cstrike\configs\stats.ini"
  Delete "$INSTDIR\files\cstrike\configs\plugins.ini"
  Delete "$INSTDIR\files\cstrike\configs\modules.ini"
  Delete "$INSTDIR\files\cstrike\configs\maps.ini"
  Delete "$INSTDIR\files\cstrike\configs\cvars.ini"
  Delete "$INSTDIR\files\cstrike\configs\core.ini"
  Delete "$INSTDIR\files\cstrike\configs\cmds.ini"
  Delete "$INSTDIR\files\cstrike\configs\amxx.cfg"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\testsuite\trietest.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\testsuite\sqlxtest.sql"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\testsuite\sqlxtest.sq3"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\testsuite\sqlxtest.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\testsuite\sorttest.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\testsuite\nvault_test.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\testsuite\native_test.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\testsuite\menutest.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\testsuite\logtest.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\testsuite\fwdtest2.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\testsuite\fwdtest1.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\testsuite\fmttest.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\testsuite\fakemeta_tests.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\testsuite\callfunc_test.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\testsuite\arraytest.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\testsuite\admins_test.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\amxmod_compat\xtrafun.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\amxmod_compat\VexdUM_stock.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\amxmod_compat\VexdUM_const.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\amxmod_compat\VexdUM.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\amxmod_compat\Vexd_Utilities.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\amxmod_compat\translator.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\amxmod_compat\mysql.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\amxmod_compat\maths.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\amxmod_compat\amxmod.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\xtrafun.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\xs.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\Vexd_Utilities.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\vector.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\vault.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\tsx.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\tsfun.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\tsstats.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\tsconst.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\tfcx.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\tfcstats.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\tfcconst.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\time.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\svn_version.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\string.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\sqlx.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\sorting.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\sockets.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\regex.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\ns_const.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\ns2amx.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\ns.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\nvault.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\newmenus.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\message_stocks.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\message_const.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\messages.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\lang.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\hlsdk_const.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\ham_const.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\hamsandwich.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\geoip.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\fun.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\float.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\file.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\fakemeta_util.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\fakemeta_stocks.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\fakemeta_const.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\fakemeta.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\esf.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\esf_const.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\engine_stocks.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\engine_const.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\engine.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\dodx.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\dodstats.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\dodfun.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\dodconst.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\dbi.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\csx.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\cstrike.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\csstats.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\core.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\celltrie.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\cellarray.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\amxmodx.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\amxmod.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\amxmisc.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\include\amxconst.inc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\amxmod_compat\amxmod_compat.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\amxmod_compat\core.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\amxmod_compat\mysql.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\amxmod_compat\vexdum.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\timeleft.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\telemenu.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\statscfg.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\scrollmsg.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\pluginmenu.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\plmenu.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\pausecfg.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\nextmap.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\multilingual.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\menufront.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\mapsmenu.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\mapchooser.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\imessage.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\compile.sh"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\compile.exe"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\cmdmenu.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\antiflood.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\amxxpc_osx"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\amxxpc32.so"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\amxxpc32.dylib"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\amxxpc32.dll"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\amxxpc.exe"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\amxxpc"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\adminvote.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\adminslots.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\adminhelp.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\admincmd.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\adminchat.sma"
  Delete "$INSTDIR\files\base\addons\amxmodx\scripting\admin.sma"
  Delete "$INSTDIR\files\base\plugins\timeleft.amxx"
  Delete "$INSTDIR\files\base\plugins\telemenu.amxx"
  Delete "$INSTDIR\files\base\plugins\statscfg.amxx"
  Delete "$INSTDIR\files\base\plugins\scrollmsg.amxx"
  Delete "$INSTDIR\files\base\plugins\pluginmenu.amxx"
  Delete "$INSTDIR\files\base\plugins\plmenu.amxx"
  Delete "$INSTDIR\files\base\plugins\pausecfg.amxx"
  Delete "$INSTDIR\files\base\plugins\nextmap.amxx"
  Delete "$INSTDIR\files\base\plugins\multilingual.amxx"
  Delete "$INSTDIR\files\base\plugins\menufront.amxx"
  Delete "$INSTDIR\files\base\plugins\mapsmenu.amxx"
  Delete "$INSTDIR\files\base\plugins\mapchooser.amxx"
  Delete "$INSTDIR\files\base\plugins\imessage.amxx"
  Delete "$INSTDIR\files\base\plugins\cmdmenu.amxx"
  Delete "$INSTDIR\files\base\plugins\antiflood.amxx"
  Delete "$INSTDIR\files\base\plugins\admin_sql.amxx"
  Delete "$INSTDIR\files\base\plugins\adminvote.amxx"
  Delete "$INSTDIR\files\base\plugins\adminslots.amxx"
  Delete "$INSTDIR\files\base\plugins\adminhelp.amxx"
  Delete "$INSTDIR\files\base\plugins\admincmd.amxx"
  Delete "$INSTDIR\files\base\plugins\adminchat.amxx"
  Delete "$INSTDIR\files\base\plugins\admin.amxx"
  Delete "$INSTDIR\files\base\modules\nvault_amxx_i386.so"
  Delete "$INSTDIR\files\base\modules\nvault_amxx.dylib"
  Delete "$INSTDIR\files\base\modules\nvault_amxx.dll"
  Delete "$INSTDIR\files\base\modules\sockets_amxx_i386.so"
  Delete "$INSTDIR\files\base\modules\sockets_amxx.dylib"
  Delete "$INSTDIR\files\base\modules\sockets_amxx.dll"
  Delete "$INSTDIR\files\base\modules\regex_amxx_i386.so"
  Delete "$INSTDIR\files\base\modules\regex_amxx.dylib"
  Delete "$INSTDIR\files\base\modules\regex_amxx.dll"
  Delete "$INSTDIR\files\base\modules\sqlite_amxx_i386.so"
  Delete "$INSTDIR\files\base\modules\sqlite_amxx.dylib"
  Delete "$INSTDIR\files\base\modules\sqlite_amxx.dll"
  Delete "$INSTDIR\files\base\modules\mysql_amxx_i386.so"
  Delete "$INSTDIR\files\base\modules\mysql_amxx.dylib"
  Delete "$INSTDIR\files\base\modules\mysql_amxx.dll"
  Delete "$INSTDIR\files\base\modules\geoip_amxx_i386.so"
  Delete "$INSTDIR\files\base\modules\geoip_amxx.dylib"
  Delete "$INSTDIR\files\base\modules\geoip_amxx.dll"
  Delete "$INSTDIR\files\base\modules\fun_amxx_i386.so"
  Delete "$INSTDIR\files\base\modules\fun_amxx.dylib"
  Delete "$INSTDIR\files\base\modules\fun_amxx.dll"
  Delete "$INSTDIR\files\base\modules\fakemeta_amxx_i386.so"
  Delete "$INSTDIR\files\base\modules\fakemeta_amxx.dylib"
  Delete "$INSTDIR\files\base\modules\fakemeta_amxx.dll"
  Delete "$INSTDIR\files\base\modules\engine_amxx_i386.so"
  Delete "$INSTDIR\files\base\modules\engine_amxx.dylib"
  Delete "$INSTDIR\files\base\modules\engine_amxx.dll"
  Delete "$INSTDIR\files\base\modules\hamsandwich_amxx_i386.so"
  Delete "$INSTDIR\files\base\modules\hamsandwich_amxx.dylib"
  Delete "$INSTDIR\files\base\modules\hamsandwich_amxx.dll"
  Delete "$INSTDIR\files\base\dlls\metamod.so"
  Delete "$INSTDIR\files\base\dlls\metamod.dylib"
  Delete "$INSTDIR\files\base\dlls\metamod.dll"
  Delete "$INSTDIR\files\base\dlls\amxmodx_mm_i386.so"
  Delete "$INSTDIR\files\base\dlls\amxmodx_mm.dylib"
  Delete "$INSTDIR\files\base\dlls\amxmodx_mm.dll"
  Delete "$INSTDIR\files\base\data\lang\timeleft.txt"
  Delete "$INSTDIR\files\base\data\lang\time.txt"
  Delete "$INSTDIR\files\base\data\lang\telemenu.txt"
  Delete "$INSTDIR\files\base\data\lang\stats_dod.txt"
  Delete "$INSTDIR\files\base\data\lang\statsx.txt"
  Delete "$INSTDIR\files\base\data\lang\statscfg.txt"
  Delete "$INSTDIR\files\base\data\lang\scrollmsg.txt"
  Delete "$INSTDIR\files\base\data\lang\restmenu.txt"
  Delete "$INSTDIR\files\base\data\lang\plmenu.txt"
  Delete "$INSTDIR\files\base\data\lang\pausecfg.txt"
  Delete "$INSTDIR\files\base\data\lang\nextmap.txt"
  Delete "$INSTDIR\files\base\data\lang\multilingual.txt"
  Delete "$INSTDIR\files\base\data\lang\miscstats.txt"
  Delete "$INSTDIR\files\base\data\lang\menufront.txt"
  Delete "$INSTDIR\files\base\data\lang\mapsmenu.txt"
  Delete "$INSTDIR\files\base\data\lang\mapchooser.txt"
  Delete "$INSTDIR\files\base\data\lang\languages.txt"
  Delete "$INSTDIR\files\base\data\lang\imessage.txt"
  Delete "$INSTDIR\files\base\data\lang\common.txt"
  Delete "$INSTDIR\files\base\data\lang\cmdmenu.txt"
  Delete "$INSTDIR\files\base\data\lang\antiflood.txt"
  Delete "$INSTDIR\files\base\data\lang\adminvote.txt"
  Delete "$INSTDIR\files\base\data\lang\adminslots.txt"
  Delete "$INSTDIR\files\base\data\lang\adminhelp.txt"
  Delete "$INSTDIR\files\base\data\lang\admincmd.txt"
  Delete "$INSTDIR\files\base\data\lang\adminchat.txt"
  Delete "$INSTDIR\files\base\data\lang\admin.txt"
  Delete "$INSTDIR\files\base\data\GeoIP.dat"
  Delete "$INSTDIR\files\base\configs\users.ini"
  Delete "$INSTDIR\files\base\configs\sql.cfg"
  Delete "$INSTDIR\files\base\configs\speech.ini"
  Delete "$INSTDIR\files\base\configs\plugins.ini"
  Delete "$INSTDIR\files\base\configs\modules.ini"
  Delete "$INSTDIR\files\base\configs\maps.ini"
  Delete "$INSTDIR\files\base\configs\hamdata.ini"
  Delete "$INSTDIR\files\base\configs\cvars.ini"
  Delete "$INSTDIR\files\base\configs\custommenuitems.cfg"
  Delete "$INSTDIR\files\base\configs\core.ini"
  Delete "$INSTDIR\files\base\configs\configs.ini"
  Delete "$INSTDIR\files\base\configs\cmds.ini"
  Delete "$INSTDIR\files\base\configs\clcmds.ini"
  Delete "$INSTDIR\files\base\configs\amxx.cfg"
  Delete "$INSTDIR\files\amxxstudio\AMXX_Studio.exe"
  Delete "$INSTDIR\files\amxxstudio\SciLexer.dll"
  Delete "$INSTDIR\files\amxxstudio\config\ACList.cfg"
  Delete "$INSTDIR\files\amxxstudio\config\C++.csl"
  Delete "$INSTDIR\files\amxxstudio\config\Cache.cfg"
  Delete "$INSTDIR\files\amxxstudio\config\Editor.sci"
  Delete "$INSTDIR\files\amxxstudio\config\Notes.dat"
  Delete "$INSTDIR\files\amxxstudio\config\Other.csl"
  Delete "$INSTDIR\files\amxxstudio\config\Pawn.csl"
  Delete "$INSTDIR\files\amxxstudio\config\plugins.cfg"
  Delete "$INSTDIR\files\amxxstudio\config\Settings.ini"
  Delete "$INSTDIR\files\amxxstudio\plugins\Functions and Events.htm"
  Delete "$INSTDIR\files\amxxstudio\plugins\Hello World - CPP.dll"
  Delete "$INSTDIR\files\amxxstudio\plugins\Hello World - Delphi.dll"
  Delete "$INSTDIR\files\amxxstudio\plugins\Functions and Events-files\filelist.xml"
  Delete "$INSTDIR\files\amxxstudio\plugins\Functions and Events-files\sheet001.htm"
  Delete "$INSTDIR\files\amxxstudio\plugins\Functions and Events-files\sheet002.htm"
  Delete "$INSTDIR\files\amxxstudio\plugins\Functions and Events-files\stylesheet.css"
  Delete "$INSTDIR\files\amxxstudio\plugins\Functions and Events-files\tabstrip.htm"
  Delete "$INSTDIR\files\amxxstudio\plugins\Hello_World CPP\Hello_World.vcproj"
  Delete "$INSTDIR\files\amxxstudio\plugins\Hello_World CPP\Hello_World.suo"
  Delete "$INSTDIR\files\amxxstudio\plugins\Hello_World CPP\Hello_World.sln"
  Delete "$INSTDIR\files\amxxstudio\plugins\Hello_World CPP\Hello_World.dsp"
  Delete "$INSTDIR\files\amxxstudio\plugins\Hello_World CPP\Hello_World.dsw"
  Delete "$INSTDIR\files\amxxstudio\plugins\Hello_World CPP\Hello_World.ncb"
  Delete "$INSTDIR\files\amxxstudio\plugins\Hello_World CPP\Hello_World.opt"
  Delete "$INSTDIR\files\amxxstudio\plugins\Hello_World CPP\Hello_World.plg"
  Delete "$INSTDIR\files\amxxstudio\plugins\Hello_World CPP\sample.cpp"
  Delete "$INSTDIR\files\amxxstudio\plugins\Hello_World CPP\sample.h"
  Delete "$INSTDIR\files\amxxstudio\plugins\Hello_World CPP\studio_api.h"
  Delete "$INSTDIR\files\amxxstudio\plugins\Hello_World Delphi\HelloWorld.cfg"
  Delete "$INSTDIR\files\amxxstudio\plugins\Hello_World Delphi\HelloWorld.dof"
  Delete "$INSTDIR\files\amxxstudio\plugins\Hello_World Delphi\HelloWorld.dpr"
  Delete "$INSTDIR\files\amxxstudio\plugins\Hello_World Delphi\HelloWorld.res"
  Delete "$INSTDIR\files\amxxstudio\plugins\Hello_World Delphi\studioapi.pas"

  Delete "$SMPROGRAMS\$ICONS_GROUP\Uninstall.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\Website.lnk"
  Delete "$DESKTOP\AMX Mod X Studio.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\AMXX Studio.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\Documentation.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\AMX Mod X.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\AMX Mod X Studio.lnk"

  RMDir "$SMPROGRAMS\$ICONS_GROUP"
  RMDir "$INSTDIR\files\esf\configs"
  RMDir "$INSTDIR\files\esf\modules"
  RMDir "$INSTDIR\files\ts\scripting"
  RMDir "$INSTDIR\files\ts\plugins"
  RMDir "$INSTDIR\files\ts\modules"
  RMDir "$INSTDIR\files\ts\data"
  RMDir "$INSTDIR\files\ts\configs"
  RMDir "$INSTDIR\files\tfc\scripting"
  RMDir "$INSTDIR\files\tfc\plugins"
  RMDir "$INSTDIR\files\tfc\modules"
  RMDir "$INSTDIR\files\tfc\data"
  RMDir "$INSTDIR\files\tfc\configs"
  RMDir "$INSTDIR\files\ns\scripting"
  RMDir "$INSTDIR\files\ns\plugins"
  RMDir "$INSTDIR\files\ns\modules"
  RMDir "$INSTDIR\files\ns\configs"
  RMDir "$INSTDIR\files\dod\scripting"
  RMDir "$INSTDIR\files\dod\plugins"
  RMDir "$INSTDIR\files\dod\modules"
  RMDir "$INSTDIR\files\dod\data"
  RMDir "$INSTDIR\files\dod\configs"
  RMDir "$INSTDIR\files\cstrike\scripting"
  RMDir "$INSTDIR\files\cstrike\plugins"
  RMDir "$INSTDIR\files\cstrike\modules"
  RMDir "$INSTDIR\files\cstrike\data"
  RMDir "$INSTDIR\files\cstrike\configs"
  RMDir "$INSTDIR\files\base\addons\amxmodx\scripting\include\amxmod_compat"
  RMDir "$INSTDIR\files\base\addons\amxmodx\scripting\include"
  RMDir "$INSTDIR\files\base\addons\amxmodx\scripting\amxmod_compat"
  RMDir "$INSTDIR\files\base\scripting"
  RMDir "$INSTDIR\files\base\plugins"
  RMDir "$INSTDIR\files\base\modules"
  RMDir "$INSTDIR\files\base\dlls"
  RMDir "$INSTDIR\files\base\data\lang"
  RMDir "$INSTDIR\files\base\data"
  RMDir "$INSTDIR\files\base\configs"
  RMDir "$INSTDIR\AMXX Studio\config"
  RMDir "$INSTDIR\AMXX Studio\plugins"
  RMDir "$INSTDIR\AMXX Studio"
  RMDir /r "$INSTDIR"
  RMDir "$INSTDIR"
  RMDir ""

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  SetAutoClose true
SectionEnd
